//
// To compile, use the following command:
//   csc /t:library RemotePrimeCalc.cs
//
// After a successful compile, copy the RemotePrimeCalc.dll
// into the same directory as the Delphi source code.
//

using System;
using System.Collections;

namespace RickRoss.Borcon2003.RemotePrimeCalc
{
  //
  // This first class, PrimeNumberData is used for sending
  // the information back and forth between the client and
  // server. Notice that this class is Serialized.
  //
  [Serializable()]
  public class PrimeNumberData
  {
    private string _ClientName;
    private long   _StartAt;
    private long   _StopAt;
    private long[] _PrimeNumbers;
    private bool _TimeToStop;

    public string ClientName
    {
      get { return _ClientName; }
      set { _ClientName = value; }
    }

    public long StartAt
    {
      get { return _StartAt; }
      set { _StartAt = value; }
    }

    public long StopAt
    {
      get { return _StopAt; }
      set { _StopAt = value; }
    }

    public long[] PrimeNumbers
    {
      get { return _PrimeNumbers; }
      set { _PrimeNumbers = value; }
    }

    public bool TimeToStop 
    {
      get { return _TimeToStop; }
      set { _TimeToStop = value; }
    }
  }

  //
  // The IPrimeNumberServer is the contract between
  // the client and server. 
  //
  public interface IPrimeNumberServer
  {
    // client says "I need some work to do"
    // server says "Okay... here is what you need to do"
    PrimeNumberData ReadyForWork( string clientName );

    // client says "Here is the answer"
    // server accepts the data
    void PrimeNumbers( PrimeNumberData results );
  }
}