//
// To compile, use the following command:
//   csc /r:BorCon2003.dll ExampleClient1.cs
//
// This is the C# equivalent to ExampleClient1.dpr
//

using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels.Http;
using System.Runtime.Remoting.Channels;
using RickRoss.BorCon2003;

namespace RickRoss.BorCon2003.Example1
{
  class Example1Client
  {
    public static void Main(string[] args)
    {
      string SERVER_URL = "http://localhost:2003/BorCon2003RemoteObject.soap";

      Console.WriteLine("Remote client is creating HTTP channel...");
      HttpChannel aChannel = new HttpChannel();

      Console.WriteLine("Registering client channel");
      ChannelServices.RegisterChannel( aChannel );

      Console.WriteLine("Obtaining reference to server...");
      IExample1 iex1 = (IExample1) Activator.GetObject( typeof( IExample1 ), SERVER_URL );

      Console.WriteLine("Object reference has been required...");
      Console.WriteLine("Getting value... {0}", iex1.GetValue() );
      Console.WriteLine("Setting value");
      iex1.SetValue( 77 );
      Console.WriteLine("Getting value again... {0}", iex1.GetValue() );               
    }
  }
}