program PublishedServer;
{$APPTYPE CONSOLE}

(*
 * To compile, make sure you have the BorCon2003.dll in this same directory, 
 * generated from the BorCon2003.cs (which is located in the ..\c#\assemblies
 * directory).
 *
 * dccil -luBorCon2003 PublishedServer.dpr 
 *
 * Use this server application with either the Delphi or C# ExampleClient1 client
 *
 *)

uses
  RickRoss.BorCon2003, // imported from BorCon2003.dll
  System.Runtime.Remoting,
  System.Runtime.Remoting.Channels.Http,
  System.Runtime.Remoting.Channels;  

type
  TMyRemoteObject = class( MarshalByRefObject, IExample1 )
  private
    FValue : integer;
  public
    constructor Create( initialValue : integer );
    procedure SetValue( value : integer );
    function  GetValue : integer;
  end;

constructor TMyRemoteObject.Create( initialValue : integer );
begin
  inherited Create;
  writeln('Server: created TMyRemoteObject with value of ',initialValue );
  FValue := initialValue;
end;

procedure TMyRemoteObject.SetValue( value : integer );
begin
  writeln('Server: Setting value to ', value);
  FValue := value;
end;

function  TMyRemoteObject.GetValue : integer;
begin
  writeln('Server: getting value ', FValue );
  Result := FValue;
end;

var
  aChannel : HttpChannel;
  myobj    : TMyRemoteObject;

begin
  writeln('RemoteServer (Singleton) starting...');
  aChannel := HttpChannel.Create( 2003 ); // port number
  writeln('Server: Registering channel...');
  ChannelServices.RegisterChannel( aChannel );
  writeln('Server: creating instance of the object...');
  myobj  := TMyRemoteObject.Create( 2003 );
  writeln('Server: marshalling created object...');
  RemotingServices.Marshal(myobj, 'BorCon2003RemoteObject.soap');
  writeln('Press return to shut down the server...');
  readln;  
end.
